
struct evttab {
	enum logging {
		silence =	0x0000,	// as is
		tolog =		0x0001,	// write to log
		toscreen =	0x0002,	// write to screen
		tomsg =		0x0004,	// write to message
		everywhere = (tolog|toscreen|tomsg)
	};
	enum impotence {
		ignore = 0,
		warn,
		err,
		crash
	};

	int		code;
	impotence	imp;
	logging		log;
};

struct evtl {
	int	code;
	char *	comment;
	
};

class evtLog: public dynArr<evtl> {
public:
	int	maxImp;

	evtLog(void): dynArr<evtl>(50,50){maxImp=0;}
};



// Event reactions
#define	EVT_NONE	0
#define	EVT_WARN	1
#define	EVT_ERR 	2

// Logged events
#define	E_NOCONFIG	1	// Can't open config
#define	E_NOLOG		2	// Can't open logfile
#define	E_CONFIG	3	// Config error, not fatal
#define	E_FATAL		4	// Config error, fatal

#define E_CFG_OK	100	// delimiter only

#define E_NOTIFY	101	// processing notes
#define E_SYNTAX	102	// row format
#define E_ILLFLAG	103	// unknown flag
#define E_IMPLIED	104	// implied flag
#define E_ILLPVT	105	// illegal pvt
#define E_ILLPHONE	106	// illegal phone

struct reaction {
	int	code;
	int	toMsg;
	int	errClass;	// ERR
};

struct errorlog {
	int	code;
	char 	reason[60];
};
void	toLog(int code, char * reason);
