#include <stdlib.h>
// simple dynamic array. Not fool proof, sorry.
// !!! Objects have been contructed _only_ under nArr watermark

typedef int	boolean;

template<class Type>
class dynArr {
protected:
	Type *	*Arr;
	size_t	nArr;
	size_t	sArr;
	size_t	eArr;
private:
	boolean extend(void) {
		Type ** tmp = Arr;
		if ((Arr = (Type **)realloc(Arr, (sArr+eArr)*sizeof(Type*))) != NULL) {
			size_t	i;
			for (i = sArr; i < sArr+eArr; i++)
				Arr[i] = NULL;
			sArr = sArr+eArr;
			return	1;
		} else {
			Arr = tmp;
			return 0;
		}
	}
public:
	dynArr<Type>(size_t initial, size_t ext = 50): eArr(ext) {
		nArr = sArr = 0;
// printf("dynArr %d %d\n", initial,ext);fflush(stdout);
		if ((Arr = (Type **)malloc(initial*sizeof(Type*))) != NULL) {
			size_t	i;
			sArr = initial;
			for (i = 0; i < sArr; i++)
				Arr[i] = NULL;
		}
	}
	~dynArr<Type>(void) {
		size_t	i;
		for (i = 0; i < nArr; i++)
			if (Arr[i] != NULL) {	// Just a paranoya
				Arr[i]->~Type();
				delete Arr[i];
			}
		sArr = 0;
		free(Arr);
	}

	// usage: Array.add(new Type(...));
	boolean add(Type * t) { 
		boolean rc;
		if (nArr >= sArr && !extend())
			return 0;
		Arr[nArr++] = t;
		return 1;
	}
	Type & operator[](size_t idx) {return *Arr[idx];}
	size_t nItems(void) const {return nArr;}
};

